// NSDoc.cpp : CNSDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "nshogi2.h"

#include "NSDoc.h"
#include "serverDlg.h"
#include "clientDlg.h"
#include "msg.h"
#include "msgdlg.h"
#include "resultdlg.h"
#include "maildlg.h"
#include "NewBtlDlg.h"
#include "SockStatus.h"
#include "UwateDlg.h"

#include "mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PORTNOPLUS	0
#define NETSHOGIFILE	_T("NS2Rsult.txt")
BOOL WriteResultStatus( CString name, int nWin, int nLose );
BOOL ReadResultStatus( CString name, int* nWin, int* nLose );

//////////////////////////////////////////////////////////////////////////////
//
// TEh\[X特Đ
//

void myPlaySound(int nRes) 
{
	CNShogiApp* pApp = NULL;
	pApp = (CNShogiApp*)AfxGetApp();

	if(pApp==NULL)
		return;

	if(pApp->m_rgst.m_nSoundOn != 1)
		return;

	HINSTANCE hInst = AfxGetResourceHandle();

	HRSRC hRes = FindResource( 
		hInst,						// resource-module handle 
		MAKEINTRESOURCE(nRes),		// pointer to resource name 
		_T("WAVE")					// pointer to resource type
	); 

	HGLOBAL hSnd = NULL;
	if (hRes != NULL)
		hSnd = LoadResource(hInst, hRes);

	HMODULE hMod = NULL;
	if(hSnd != NULL )
		 hMod = (HMODULE)LockResource(hSnd);

	if(hMod != NULL)
		int a = ::sndPlaySound((LPCTSTR)hMod,
		SND_NODEFAULT|SND_MEMORY|SND_ASYNC);

}

/////////////////////////////////////////////////////////////////////////////
// CNSDoc
//
//

IMPLEMENT_DYNCREATE(CNSDoc, CDocument)

BEGIN_MESSAGE_MAP(CNSDoc, CDocument)
	//{{AFX_MSG_MAP(CNSDoc)
	ON_COMMAND(ID_CON_CLIENT, OnConClient)
	ON_COMMAND(ID_CON_DISCONNECT, OnConDisconnect)
	ON_COMMAND(ID_CON_SERVER, OnConServer)
	ON_UPDATE_COMMAND_UI(ID_CON_CLIENT, OnUpdateConClient)
	ON_UPDATE_COMMAND_UI(ID_CON_DISCONNECT, OnUpdateConDisconnect)
	ON_UPDATE_COMMAND_UI(ID_CON_SERVER, OnUpdateConServer)
	ON_COMMAND(ID_BTL_NEW, OnBtlNew)
	ON_UPDATE_COMMAND_UI(ID_BTL_NEW, OnUpdateBtlNew)
	ON_COMMAND(ID_BTL_GIVEUP, OnBtlGiveup)
	ON_UPDATE_COMMAND_UI(ID_BTL_GIVEUP, OnUpdateBtlGiveup)
	ON_COMMAND(ID_BTL_WAIT, OnBtlWait)
	ON_UPDATE_COMMAND_UI(ID_BTL_WAIT, OnUpdateBtlWait)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(ID_FILE_CUT_TAIL, OnFileCutTail)
	ON_UPDATE_COMMAND_UI(ID_FILE_CUT_TAIL, OnUpdateFileCutTail)
	ON_UPDATE_COMMAND_UI(ID_FILE_MRU_FILE1, OnUpdateFileMruFile1)
	ON_COMMAND(ID_BTL_MAIL, OnBtlMail)
	ON_UPDATE_COMMAND_UI(ID_BTL_MAIL, OnUpdateBtlMail)
	ON_COMMAND(ID_CON_WATCH, OnConWatch)
	ON_UPDATE_COMMAND_UI(ID_CON_WATCH, OnUpdateConWatch)
	ON_COMMAND(ID_BTL_INIT, OnBtlInit)
	ON_UPDATE_COMMAND_UI(ID_BTL_INIT, OnUpdateBtlInit)
	ON_COMMAND(ID_CON_PROP, OnConProp)
	ON_COMMAND(ID_FILE_SAVE_KIF_STYLE, OnFileSaveKifStyle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNSDoc NX̍\z/

CNSDoc::CNSDoc()
{
	// TODO:
	m_nViewSide = SENTE;				// ŕ\Aŕ\
	m_pApp = (CNShogiApp*)AfxGetApp();	// ̃NXŎgp`
	m_pSocket = NULL;					// ΐڑp\Pbg
	m_pSrvSocket = NULL;				// ΐڑpT[o\Pbg
	m_pGSrvSocket = NULL;				// ϐҗpT[o\Pbg
	m_pFile = NULL;						// ΐڑp\Pbgt@C
	m_pArchiveIn = NULL;				// ΐڑpA[JCo
	m_pArchiveOut = NULL;				// 
	m_pMsgDlg = NULL;					// ڑ҂_CAOnh
	m_bOnGame = FALSE;					// Q[tO
	m_nMySide=SENTE;					// tO
	m_bIamGallary = FALSE;				// ͊ϐ҂ł
	m_nSenteTime=0;
	m_nGoteTime	=0;
	m_nCounter	=0;
	m_nDefaultCounter = 0;

	TRY
	{
		m_pKifu = new CPtrList(100);
	}CATCH(CMemoryException, e)
	{
		AfxMessageBox( IDS_ERRMEMORY,MB_ICONSTOP );
		exit( -1 );
	}
	END_CATCH
	
	Init();

}

//////////////////////////////////////////////////////////////////////////////
//
CNSDoc::~CNSDoc()
{
	///
	SendMsg(MSG_DISCONNECT);	// ΐ҂Ɛڑ̎͐ؒfbZ[W𑗐M
	ShowMsg(FALSE);				// ڑ҂_CAOI
	DeleteSocket();				// ΐҗp\PbgAA[JCoI
	PDELETE(m_pKifu);			// t@C폜
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::DeleteContents() 
{
	// TODO:
	m_szSenteName = "";
	m_szGoteName = "";

	CDocument::DeleteContents();
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::Init()
{
	m_koma.Init();

	if( m_pKifu != NULL )
	{
		// ̏
		m_pKifu->RemoveAll();
		m_koma.SetWord(KOMA_GAME_START, 0);
		m_koma.SetEnable(KOMA_GAME_START,FALSE);
		m_pKifu->AddTail((void*)MAKEWPARAM(m_koma.GetWord(KOMA_USER),(WORD)KOMA_GAME_START));
		m_timStart =  CTime::GetCurrentTime();
	}

	CNSView* pView = GetSDIView();
	if( pView != NULL )
		pView->UpdateKifuBar();

}

//////////////////////////////////////////////////////////////////////////////
//
BOOL CNSDoc::OnNewDocument()
{
	if (IsModified())
	{
		CString cs;
		cs = GetTitle() + _T(" ւ̕ύXۑ܂H");
		switch( AfxMessageBox(cs,MB_YESNOCANCEL|MB_ICONEXCLAMATION) )
		{
		case IDYES:
		{
			CDocument::DoSave(NULL);
			break;
		}
		case IDCANCEL:
			return FALSE;
		case IDNO:
		default:
			break;
		}
	}
	if (!CDocument::OnNewDocument())
		return FALSE;
	// TODO:
	// (SDI hLg͂̃hLgėp܂B)
	Init();
	UpdateMyView();
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CNSDoc VAC[[V
// t@CtH[}bg
// m_nSenteTime;
// m_nGoteTime;
// m_nMySide;
// m_bCountUp;
// m_nDefaultCounter;

void CNSDoc::Serialize(CArchive& ar)
{
	// TODO:
	// hLgt@Cʗp
	char str[] = { 'N','E','T','S','H','O','G','I','2','0', '\0' };

	if (ar.IsStoring())
	{
		if( !m_pApp->m_bRegisted )
		{
			AfxMessageBox( _T("WXgo^ĂB\ñt@C쐬܂B") );
			for( int jj = 0; jj < 1024; jj++ )
				ar << (DWORD)0;
			return;
		}


		for( int jj=0; jj < 11; jj++ )
			ar << (char)str[jj];

		m_koma.Serialize( ar );
		
		ar << m_pKifu->GetCount();
		for( POSITION pos = m_pKifu->GetHeadPosition(); pos != NULL;)
		{
			// Doc̊Xgf[^
			ar << (DWORD)(m_pKifu->GetNext( pos ));
		}
		ar << m_nSenteTime;
		ar << m_nGoteTime;
		ar << m_nMySide;
		ar << m_bCountUp;
		ar << m_nDefaultCounter;
	}
	else
	{
		char strRecv[15];
		
		for( int jj=0; jj < 11; jj++ )
			ar >> strRecv[jj];

		strRecv[10] = '\0';
		if( lstrcmp( str, strRecv ) != 0 )
		{
			AfxMessageBox(_T("ȃt@CłB"),MB_ICONEXCLAMATION);
			return;
		}
		
		// f[^̓ǂݍ݊Jn
		m_koma.Serialize( ar );

		int nCount;
		DWORD dwData;
		Init();
		m_pKifu->RemoveAll();
		ar >> nCount;
		for(int ii = 0; ii < nCount;ii++)
		{
			ar >> dwData;
			m_koma.SetWord(HIWORD(dwData),LOWORD(dwData));
			WriteRecord(HIWORD(dwData));
		}
		ar >> m_nSenteTime;
		ar >> m_nGoteTime;
		ar >> m_nMySide;
		ar >> m_bCountUp;
		ar >> m_nDefaultCounter;
	}

	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return;
	pView->UpdateKifuBar();

}

/////////////////////////////////////////////////////////////////////////////
// CNSDoc NX̐ff

#ifdef _DEBUG
void CNSDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CNSDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNSDoc R}h

void CNSDoc::OnUpdateKoma()
{
	
}

//////////////////////////////////////////////////////////////////////////////
// T[o\PbgFt

void CNSDoc::ProcessPendingAccept()
{
	ShowMsg(FALSE);
	
	// ΐ҂ڑꂽƂ̏
	m_pSocket = new CClientSocket(this);

	if (m_pSrvSocket->Accept(*m_pSocket))
	{
		// A[JCo̍쐬
		m_pFile = new CSocketFile(m_pSocket);
		m_pArchiveIn = new CArchive(m_pFile,CArchive::load);
		m_pArchiveOut = new CArchive(m_pFile,CArchive::store);
		
		SendMsg( MSG_CONNECT );
	}
	else
	{
		delete m_pSocket;
		AfxMessageBox(_T("T[oڑtɃG[܂"),MB_ICONEXCLAMATION);
	}
	// XjO\Pbg̍폜
	PDELETE(m_pSrvSocket );
}

//////////////////////////////////////////////////////////////////////////////
// FM

void CNSDoc::ProcessPendingRead()
{
	do
	{
		if(!ReceiveMsg()||m_pSocket==NULL)
			return;
	}
	while(!m_pArchiveIn->IsBufferEmpty());
}

//////////////////////////////////////////////////////////////////////////////
// j[FNCAgƂăT[oɐڑɍs

void CNSDoc::OnConClient() 
{
	// TODO:
	CWaitCursor wait;
	
	if( m_pSocket != NULL )
	{
		AfxMessageBox(_T("܂ڑł"),MB_ICONEXCLAMATION );
		return;
	}

	if( m_pSrvSocket != NULL )
	{
		AfxMessageBox(_T("T[oƂđҋ@ł"),MB_ICONEXCLAMATION );
		return;
	}

	// ڑ_CAO\
	CClientDLG	dlg;
	
	dlg.m_szHandleName = m_pApp->m_rgst.m_szMyName;
	dlg.m_nPortNo = m_pApp->m_rgst.m_nDefPortNo;
	dlg.m_szServer = m_pApp->m_rgst.m_szDefServerName;
	
	while( TRUE )
	{
		if (IDOK != dlg.DoModal()){
			return;
		}
		
		// ڑ
		if (ConnectSocket(dlg.m_szHandleName, dlg.m_szServer, dlg.m_nPortNo) )
		{

			m_pApp->m_rgst.m_szMyName = dlg.m_szHandleName;
			m_pApp->m_rgst.m_nDefPortNo = dlg.m_nPortNo;
			m_pApp->m_rgst.m_szDefServerName = dlg.m_szServer;

			// ڑɐAʐM̕ۑs
			dlg.m_RhnHost.Add(dlg.m_szServer);
			dlg.m_RhnHost.WriteList();

			SendMsg( MSG_CONNECT );
			return;
		}

		if( AfxMessageBox(_T("ݒςĂxH"),MB_YESNO|MB_ICONQUESTION) == IDNO )
			return;
	}
}

//////////////////////////////////////////////////////////////////////////////
// j[Fؒf

void CNSDoc::OnConDisconnect() 
{
	// TODO:
	BOOL b = ShowMsg(FALSE);

	if( AfxMessageBox(_T("ʐMؒf܂H"),
		MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)==IDYES)
	{
		SendMsg(MSG_DISCONNECT);
		DeleteSocket();
		AfxMessageBox(IDS_DISCONNECT,MB_ICONINFORMATION);
	}
	else
		ShowMsg(b);

}


//////////////////////////////////////////////////////////////////////////////
// j[FT[oҋ@

void CNSDoc::OnConServer() 
{
	if( m_pSocket != NULL )
	{
		AfxMessageBox(_T("܂ڑł"),MB_ICONEXCLAMATION );
		return;
	}

	if( m_pSrvSocket != NULL )
	{
		AfxMessageBox(_T("ɐڑtł"),MB_ICONQUESTION );
		return;
	}
	// ڑ_CAO
	CServerDlg	dlg;
	
	dlg.m_szHandleName = m_pApp->m_rgst.m_szMyName;
	dlg.m_nPortNo = m_pApp->m_rgst.m_nDefPortNo;

	if (dlg.DoModal() == IDOK)
	{
		m_pApp->m_rgst.m_szMyName = dlg.m_szHandleName;
		m_pApp->m_rgst.m_nDefPortNo = dlg.m_nPortNo;
		m_pApp->m_rgst.Save(); // ftHgWXgɃZ[u

		m_pSrvSocket = new CServerSocket(this);
		if (m_pSrvSocket->Create(dlg.m_nPortNo+PORTNOPLUS))
		{
			if (m_pSrvSocket->Listen())
			{
				ShowMsg(TRUE);
				if(!CreateGallarySocket())
					AfxMessageBox(_T("ϐҗpJݏo܂łB"),MB_ICONEXCLAMATION);
				return;	// ڑҋ@I
			}
		}
		// ڑҋ@s
		PDELETE( m_pSrvSocket )
		AfxMessageBox(_T("G[̂ߑҋ@o܂łB\nςĂ݂ĂB"),MB_ICONEXCLAMATION);
	}
}

//////////////////////////////////////////////////////////////////////////////
// M[T[o\Pbg쐬

BOOL CNSDoc::CreateGallarySocket()
{

	// M[T[o\Pbg
	m_pGSrvSocket = new CServerSocket(this,TRUE);
	if (m_pGSrvSocket->Create(m_pApp->m_rgst.m_nDefPortNo +1 +PORTNOPLUS))
	{
		if (m_pGSrvSocket->Listen())
		{
			return TRUE;
		}
	}
	// ڑҋ@s
	PDELETE( m_pGSrvSocket )
	AfxMessageBox(_T("G[̂ߊϐҋ@o܂łB"),MB_ICONEXCLAMATION);
	return FALSE;
}


//////////////////////////////////////////////////////////////////////////////
// \Pbg폜

void CNSDoc::DeleteSocket()
{
	m_bIamGallary = FALSE;
	m_bOnGame = FALSE;
	m_szEnemyName = "";
	m_szSenteName = m_pApp->m_rgst.m_szMyName;
	m_szGoteName = "";

	if(m_pArchiveOut!=NULL)
		m_pArchiveOut->Abort();

	// A[JCo폜
	PDELETE( m_pArchiveOut );
	PDELETE( m_pArchiveIn );
	PDELETE( m_pFile );

	BYTE Buffer[50];

	if (m_pSocket != NULL)
	{
		// M̋֎~
		m_pSocket->ShutDown();

		// c̎MׂĎ̂Ă
		while(m_pSocket->Receive(Buffer,50) > 0);
	}

	// \Pbg폜
	PDELETE( m_pSocket );
	PDELETE( m_pSrvSocket );
	PDELETE( m_pGSrvSocket );	// M[T[o\Pbg

	// ϐp\Pbǧn
	while(!m_connectionList.IsEmpty())
	{
		CWatchSocket* pWSocket = (CWatchSocket*)m_connectionList.RemoveHead();

		SendMsg2Gallary(pWSocket,MSG_GALLARY_DISCONNECT);

		if (!pWSocket->IsAborted())
		{
			pWSocket->ShutDown();

			while (pWSocket->Receive(Buffer,50) > 0);

			PDELETE(pWSocket);
		}
	}
	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return;
	pView->UpdateKifuBar();
}

/////////////////////////////////////////////////////////////////////////////
// Command UI nh

void CNSDoc::OnUpdateConClient(CCmdUI* pCmdUI) 
{
	if( m_pSocket != NULL || m_pSrvSocket != NULL )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
	
}

//////////////////////////////////////////////////////////////////////////////
//

void CNSDoc::OnUpdateConDisconnect(CCmdUI* pCmdUI) 
{
	if( m_pSocket != NULL || m_pSrvSocket != NULL )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

//////////////////////////////////////////////////////////////////////////////
//

void CNSDoc::OnUpdateConServer(CCmdUI* pCmdUI) 
{
	if( m_pSocket != NULL || m_pSrvSocket != NULL )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}


//////////////////////////////////////////////////////////////////////////////
// \Pbg̍쐬

BOOL CNSDoc::ConnectSocket(LPCTSTR lpszHandle, LPCTSTR lpszAddress, UINT nPort)
{
	m_pSocket = new CClientSocket(this);

	if (!m_pSocket->Create())
	{
		PDELETE( m_pSocket );
		AfxMessageBox(_T("\Pbg܂łB"),MB_ICONEXCLAMATION);
		return FALSE;
	}

	if(!m_pSocket->Connect(lpszAddress, nPort + PORTNOPLUS))
	{
		AfxMessageBox(_T("ڑł܂łB"),MB_ICONEXCLAMATION);
		PDELETE( m_pSocket );
		return FALSE;
	}

	// A[JCo̍쐬
	m_pFile = new CSocketFile(m_pSocket);
	m_pArchiveIn = new CArchive(m_pFile,CArchive::load);
	m_pArchiveOut = new CArchive(m_pFile,CArchive::store);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
// Viewւ̃|C^Ԃ

CNSView* CNSDoc::GetSDIView()
{
	POSITION pos = GetFirstViewPosition();
	if(pos==NULL)
	{
		return NULL;
	}

	return (CNSView*)GetNextView(pos);
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnKifuListClicked(int nIndex)
{

}


//////////////////////////////////////////////////////////////////////////////
// noŎꂽ݂̋̏Ԃɏ݂

void CNSDoc::WriteRecord(int no)
{
#ifdef _DEBUG
	if(( no == KOMA_GOTE_TIMEOUT)||( no == KOMA_GOTE_TIMEOUT))
		int aa = 00;
#endif

	myPlaySound(IDR_SNDBISHI);

	// ԃZbg
	m_nCounter	=	m_nDefaultCounter;

	DWORD dwData =  MAKEWPARAM( m_koma.GetWord(no),(WORD)no);

	// Doc̊ɒǉ
	m_pKifu->AddTail((void*)dwData);

	// ɂĔՖʂ쐬
	ReplayKoma(m_pKifu->GetCount());

	// hLg_[eBɂ
	SetModifiedFlag();
	
	// M[֑łzz
	if(m_pGSrvSocket)
		Send2AllGallary(MSG_GALLARY_DATA);
	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return;
	pView->UpdateKifuBar();


}


//////////////////////////////////////////////////////////////////////////////
// ɍ킹ĔՖʂ쐬

void CNSDoc::ReplayKoma(int nIndex)
{
	CNSView* pView = GetSDIView();
	
	// ̓_łƂ߂
	if(pView != NULL)
		pView->m_bFlashFlag=FALSE;
	
	int nLimit = 0;
	m_koma.Init();

	// 
    for( POSITION pos = m_pKifu->GetHeadPosition(); pos != NULL;)
    {
		// Doc̊Xgf[^
		DWORD dwData = (DWORD)(m_pKifu->GetNext( pos ));
		// f[^𕪉
		WORD no = HIWORD(dwData);
		// f[^𔽉f
		m_koma.SetWord(KOMA_USER,LOWORD(dwData));
		CPoint cp = m_koma.GetPoint(KOMA_USER);
		m_koma.Move(no, cp, TRUE);
		if(m_koma.IsNari(KOMA_USER))
			m_koma.SetNari(no, TRUE);
		
		if(nIndex < ++nLimit)
			break;
    }
}

//////////////////////////////////////////////////////////////////////////////
//

void CNSDoc::SendMsg(DWORD dwCommand)
{
	if (m_pArchiveOut != NULL)
	{
		// bZ[W̍쐬
		CMsg msg(this);
		msg.m_dwCmd = dwCommand;
		// M
		TRY
		{
			msg.Serialize(*m_pArchiveOut);
			m_pArchiveOut->Flush();
		}
		CATCH(CFileException, e)
		{
			m_pArchiveOut->Abort();
			delete m_pArchiveOut;
			m_pArchiveOut = NULL;
		
			//CString strTemp;
			AfxMessageBox(_T("肪f[^M܂B"
				"\nʐMؒfĂB"),MB_ICONSTOP);

		}
		END_CATCH
	}
}


//////////////////////////////////////////////////////////////////////////////
// 炩ُ̈픭ɂFALSEԂ悤
BOOL CNSDoc::ReceiveMsg()
{
	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return FALSE;

	CMsg msg(this);

	TRY
	{
		msg.Serialize(*m_pArchiveIn);

	}
	CATCH(CFileException, e)
	{
		// A[JCo鏈
		// O𔭐ɏI(Abort)
		m_bOnGame = FALSE;
		AfxMessageBox(_T("ʐMُI܂"),MB_ICONEXCLAMATION);
		return FALSE;
	}
	END_CATCH

	// ǉbZ[WM
	switch( msg.m_dwCmd )
	{
	case MSG_DATA:
	{
		// ԃZbg
		m_nCounter	=	m_nDefaultCounter;
		
		pView->m_bFlashFlag=TRUE;
		UpdateMyView();

		if((m_koma.IsBeDead(m_koma.GetGyokuNo(!(m_koma.GetSide(HIWORD(m_pKifu->GetTail()))))))
			&&(m_pApp->m_rgst.m_bOuteNotice))
			AfxMessageBox(_T("łB"),MB_ICONINFORMATION);

		break;
	}
	case MSG_GALLARY_DATA:
	{
		pView->m_bFlashFlag=TRUE;
		UpdateMyView();
		break;
	}

	case MSG_TIMEOUT:		// 肪Ԑ؂̎
	{
		// ΋ǏI
		m_bOnGame = FALSE;
		AfxMessageBox(_T("Ԑ؂łB\n΋ǏI܂B"),MB_ICONINFORMATION);

		// ʕ\
		Result(TRUE);

		break;
	}
	case MSG_GAME_END:		// ꂽ
	{
		pView->m_bFlashFlag=FALSE;
		if(m_nMySide==SENTE)
			WriteRecord( KOMA_GOTE_SYORI );
		else
			WriteRecord( KOMA_SENTE_SYORI );

		// ΋ǏI
		m_bOnGame = FALSE;
		AfxMessageBox(_T("Ȃ̕łB\n΋ǏI܂B"),MB_ICONINFORMATION);

		// ʕ\
		Result(TRUE);

		break;
	}
	
	case MSG_NOTICE:
	{
		if(  ( (CNShogiApp*)AfxGetApp() )->m_rgst.m_nSoundOn  )
			MessageBeep(MB_ICONINFORMATION);

		if(  ( (CNShogiApp*)AfxGetApp() )->m_rgst.m_nMessageOn  )
			AfxMessageBox(  _T("Ȃ̔ԂłB"),MB_ICONINFORMATION  );
		
		break;
	}

	case MSG_CONNECT:		//>> ڑbZ[W
	{
		// Ƃ肠OĂ
		m_szSenteName = m_szEnemyName;
		m_szGoteName = m_pApp->m_rgst.m_szMyName;
		
		// ΐ퐬т̕\
		int nWin,nLose;
		CString cs;
		ReadResultStatus( m_szEnemyName, &nWin, &nLose );
		cs.Format( _T("ڑ܂\n܂ł%sƂ̑ΐ퐬\n%d  %d s\n"),
			m_szEnemyName, nWin,nLose );

		AfxMessageBox( cs, MB_ICONINFORMATION );		
		
		break;
	}
	case MSG_GALLARY_DISCONNECT:
	case MSG_DISCONNECT:	//>> ڑbZ[W
	{
		pView->m_bFlashFlag=FALSE;
		m_bOnGame = FALSE;
		DeleteSocket();
		AfxMessageBox(IDS_DISCONNECT,MB_ICONEXCLAMATION);
		break;
	}
	case MSG_BTL_NEW_SENTE:	//>> VKQ[v 
	case MSG_BTL_NEW_GOTE:	//>> VKQ[v 
	{
		m_bOnGame = FALSE;
		
		CString tmpmsg;
		if( msg.m_dwCmd == MSG_BTL_NEW_SENTE )
			tmpmsg = _T("΋ǂv܂B\nȂł낵łH");
		else
			tmpmsg = _T("΋ǂv܂B\nȂł낵łH");

		if( AfxMessageBox(tmpmsg, MB_YESNO|MB_ICONQUESTION) == IDYES )
		{
			if( msg.m_dwCmd == MSG_BTL_NEW_SENTE )
			{
				// ΋Ǘ
				m_nMySide = GOTE;
				m_nViewSide = GOTE;
				m_szSenteName = m_szEnemyName;
				m_szGoteName = m_pApp->m_rgst.m_szMyName;
			}
			else
			{
				m_nMySide = SENTE;
				m_nViewSide = SENTE;
				m_szGoteName = m_szEnemyName;
				m_szSenteName = m_pApp->m_rgst.m_szMyName;
			}
			m_bOnGame = TRUE;
			UpdateMyView();
			pView->UpdateKifuBar();

			// ^Cg̍쐬
			CString title;
			CString name = m_szEnemyName;
			title.Format( "%s-%s", m_szEnemyName, m_pApp->m_rgst.m_szMyName );
			SetTitle( title );
			SendMsg(MSG_BTL_NEW_OK);
		}
		else
			SendMsg(MSG_BTL_NEW_NG);
		break;
	}

	case MSG_BTL_NEW_OK:	//>> VKQ[t 
	{
		SendMsg(MSG_KIFUDATA);
		m_bOnGame = TRUE;

		if(m_nMySide==SENTE)
		{
			m_szSenteName = m_pApp->m_rgst.m_szMyName;
			m_szGoteName = m_szEnemyName;
		}
		else
		{
			m_szSenteName = m_szEnemyName;
			m_szGoteName = m_pApp->m_rgst.m_szMyName;
		}

		// ^Cg̍쐬
		CString title;
		CString name = m_szEnemyName;
		title.Format( "%s-%s", m_szEnemyName, m_pApp->m_rgst.m_szMyName );
		SetTitle( title );
		pView->UpdateKifuBar();

		Send2AllGallary(MSG_GALLARY_KIFUDATA);

		AfxMessageBox(_T("΋ǊJn𗹏܂B\n΋ǂJn܂B"),MB_ICONINFORMATION);
		break;
	}

	case MSG_BTL_NEW_NG:	// VKQ[t 
	{
		m_bOnGame = FALSE;
		pView->UpdateKifuBar();
		AfxMessageBox(_T("΋ǊJnۂ܂B"),MB_ICONINFORMATION);
		break;
	}

	case MSG_GIVEUP:		// t
	{
		pView->m_bFlashFlag=FALSE;
		m_bOnGame = FALSE;
		AfxMessageBox(_T("ΐ푊肪Ă܂B"),MB_ICONINFORMATION);
		Result(TRUE);
		break;
	}

	case MSG_MATTA:
	{
		pView->m_bFlashFlag=FALSE;
		if( AfxMessageBox(_T("҂v܂B\n܂H"),MB_YESNO|MB_ICONQUESTION) == IDYES )
		{
			SendMsg(MSG_MATTA_OK);
			
			if((m_pKifu->GetCount()%2) == 1) // ̔
			{
				if(m_nMySide == SENTE)
					RollBack(1); // ̔
				else
					RollBack(2); // ̔
			}
			else // ̔
			{
				if(m_nMySide == GOTE)
					RollBack(1); // ̔
				else
					RollBack(2); // ̔
			}

			pView->UpdateKifuBar();
		}
		else
			SendMsg(MSG_MATTA_NG);
		break;
	}

	case MSG_MATTA_OK:
	{
		pView->m_bFlashFlag=FALSE;
		if((m_pKifu->GetCount()%2) == 1) // ̔
		{
			if(m_nMySide == SENTE)
				RollBack(2); // ̔
			else
				RollBack(1); // ̔
		}
		else // ̔
		{
			if(m_nMySide == GOTE)
				RollBack(2); // ̔
			else
				RollBack(1); // ̔
		}

		pView->UpdateKifuBar();
		AfxMessageBox(_T("҂܂B"),MB_ICONINFORMATION);
		break;
	}

	case MSG_MATTA_NG:
	{
		pView->m_bFlashFlag=FALSE;
		AfxMessageBox(_T("҂͂߂łB"),MB_ICONINFORMATION);
		break;
	}

	case MSG_MAIL:
	{
		CMailDlg dlg;
		dlg.m_szMailString = m_szMailString;

		if( dlg.DoModal() == IDOK )
		{
			// [M
			m_szMailString = dlg.m_szMailString;
			SendMsg( MSG_MAIL );
		}
		break;
	}

	default:
		break;
	}
	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnBtlNew() 
{
	if(m_bOnGame==TRUE)
		return;

	// TODO:
	// IĂꍇ͎n߂ȂB
	for( POSITION pos = m_pKifu->GetHeadPosition(); pos != NULL;)
	{
		switch(HIWORD(m_pKifu->GetNext( pos )))
		{
		case KOMA_SENTE_TORYO:
		case KOMA_GOTE_TORYO:
		case KOMA_SENTE_SYORI:
		case KOMA_GOTE_SYORI:
		case KOMA_SENTE_TIMEOUT:
		case KOMA_GOTE_TIMEOUT:
		{
			AfxMessageBox(_T("̑΋ǂ͊ɏIĂ܂B\nVK쐬ĉB"),MB_ICONINFORMATION);
			return;
		}
		default:
			break;
		}
	}
	//	VȂꍇAԂ͌pĎgpB
	if( m_pKifu->GetCount() != 1 )
	{
		switch( AfxMessageBox(IDS_BTL_NEW,MB_YESNOCANCEL|MB_ICONQUESTION) )
		{
		case IDYES:
			{
				m_nMySide = SENTE;
				m_nViewSide = SENTE;
				m_szSenteName = m_pApp->m_rgst.m_szMyName;
				m_szGoteName = m_szEnemyName;
				SendMsg(MSG_BTL_NEW_SENTE);
				UpdateMyView();	
				break;
			}
		case IDNO:
			{
				m_nMySide = GOTE;
				m_nViewSide = GOTE;
				m_szSenteName = m_szEnemyName;
				m_szGoteName = m_pApp->m_rgst.m_szMyName;
				SendMsg(MSG_BTL_NEW_GOTE);
				UpdateMyView();	
				break;
			}
		default:
				break;
		}
		return;
	}
	
	// V̏ꍇB
	CNewBtlDlg	dlg(&m_koma);
	if( IDOK == dlg.DoModal() )
	{
		m_bCountUp = m_pApp->m_rgst.m_bCountUp = dlg.m_bLimitTime;
		
		if( m_bCountUp ==TRUE )
		{
			// Ԑ̏ꍇ
			m_nSenteTime = m_nGoteTime = m_pApp->m_rgst.m_nTime 
				= dlg.m_e_hour * 3600 + dlg.m_e_min * 60;
			m_nDefaultCounter = m_pApp->m_rgst.m_nDefaultCounter = dlg.m_e_count;
			m_nCounter = m_nDefaultCounter;
		}
		else
		{
			// ԐȂ̏ꍇ
			m_nSenteTime= 0;		// 
			m_nGoteTime	= 0;		//
			m_nDefaultCounter  = 0;

		}
		m_pApp->m_rgst.Save();
		
		
		Init();

		if( dlg.m_bSente == TRUE )
		{
			m_nMySide = SENTE;
			m_nViewSide = SENTE;
			m_szSenteName = m_pApp->m_rgst.m_szMyName;
			m_szGoteName = m_szEnemyName;
			SendMsg(MSG_BTL_NEW_SENTE);
			UpdateMyView();	
		}
		else
		{
			m_nMySide = GOTE;
			m_nViewSide = GOTE;
			m_szSenteName = m_szEnemyName;
			m_szGoteName = m_pApp->m_rgst.m_szMyName;
			SendMsg(MSG_BTL_NEW_GOTE);
			UpdateMyView();	
		}
		UpdateMyView();
	}
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateBtlNew(CCmdUI* pCmdUI) 
{
	// TODO:
	if(!m_bOnGame&&m_pSocket&&m_pGSrvSocket)
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

void CNSDoc::OnBtlGiveup() 
{
	// TODO:
	ShowMsg(FALSE);
	if( AfxMessageBox(_T("܂H"),MB_YESNO|MB_ICONQUESTION)==IDYES)
	{
		if( m_nMySide == SENTE )
			WriteRecord(KOMA_SENTE_TORYO);
		else
			WriteRecord(KOMA_GOTE_TORYO);

		SendMsg(MSG_DATA);
		SendMsg(MSG_GIVEUP );
		m_bOnGame = FALSE;
		Result(FALSE);
	}

}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnBtlWait() 
{
	// TODO:
	// ΋ǒoȂB
	if(!m_bOnGame)
		return;

	if( AfxMessageBox(_T("҂v܂H"),MB_YESNO|MB_ICONQUESTION)==IDYES)
	{
		SendMsg(MSG_MATTA);
	}
}



//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateBtlGiveup(CCmdUI* pCmdUI) 
{
	// TODO:
	if( m_bOnGame )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateBtlWait(CCmdUI* pCmdUI) 
{
	// TODO:
	if( m_bOnGame )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );

	
}

//////////////////////////////////////////////////////////////////////////////
//

BOOL CNSDoc::ShowMsg(BOOL b)
{
	CWnd* pWnd = AfxGetMainWnd();

	if(b)
	{
		if(m_pMsgDlg==NULL)
		{
			pWnd->EnableWindow(FALSE);
			m_pMsgDlg = new CMsgDlg(AfxGetMainWnd(),this);
			return TRUE;
		}
		else
		{
			pWnd->EnableWindow(TRUE);
			return FALSE;
		}
	}
	else
	{
		if(m_pMsgDlg==NULL)
			return FALSE;
		else
		{
			pWnd->EnableWindow(TRUE);
			m_pMsgDlg->DestroyWindow();
			PDELETE(m_pMsgDlg);
			return TRUE;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::UpdateMyView()
{
	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CView* pView = GetNextView(pos);
		pView->InvalidateRect( NULL, FALSE );
	}   

}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::MyTimer(UINT nIDEvent)
{

	if(m_bOnGame)
	{
		// Ԑ̏ꍇ
		if( m_bCountUp )
		{
			int cnt = m_pKifu->GetCount();
			if(cnt%2==0)
			{
				if( m_nGoteTime == 3 )
				{
					//AfxMessageBox(_T("bǂ݂ɓ܂"));
				}

				if( m_nGoteTime > 0 )
					m_nGoteTime--;
				else
				{
					m_nGoteTime = 0;
					if( m_nCounter-- < 10 )
					{
						myPlaySound(IDR_SNDPIN);
					}

				}
			}
			else
			{
				if( m_nSenteTime == 3 )
				{
					//AfxMessageBox(_T("bǂ݂ɓ܂"));
				}

				if( m_nSenteTime > 0 )
					m_nSenteTime--;
				else
				{
					m_nSenteTime = 0;
					if( m_nCounter-- < 10 )
					{
						myPlaySound(IDR_SNDPIN);
					}
				}
			}


			// Ԑ؂ꏈ
			// ̏ꍇ肵܂B
			// 肪^CAEg̎̓bZ[W瑗ĂB
			if((m_pKifu->GetCount()%2) == m_nMySide )
			{
				if( m_nCounter < 1 )
				{

					if( m_nMySide == SENTE )
						WriteRecord(KOMA_SENTE_TIMEOUT);
					else
						WriteRecord(KOMA_GOTE_TIMEOUT);

					SendMsg(MSG_DATA);
					SendMsg(MSG_TIMEOUT );
					m_bOnGame = FALSE;
					AfxMessageBox(_T("Ԑ؂łB"),MB_ICONINFORMATION);
					Result(FALSE);
				}
			}
		}
		// ԐȂ̏ꍇ
		else
		{
			int cnt = m_pKifu->GetCount();
			if(cnt%2==0)
				m_nGoteTime++;
			else
				m_nSenteTime++;
		}
	

	}

}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnMsgDlgCancel()
{
	OnConDisconnect();
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::Result(BOOL bMe)
{
	CString csRes, cs;

	// ΐ퐬тc
	int nWin, nLose;
	ReadResultStatus( m_szEnemyName, &nWin, &nLose );
	bMe ? nWin++ : nLose++;
	WriteResultStatus( m_szEnemyName, nWin, nLose );

	cs.Format( "%sƂ̑ΐ퐬: %d  %d s\r\n", m_szEnemyName, nWin,nLose );
	csRes += cs;

	// ݂̎
	CTime t = CTime::GetCurrentTime();
	cs = t.Format( "%YN %m %d %H %M(%A)\r\n" );
	csRes += cs;

	cs.Format( "\tF%s\r\n\tF%s\r\n", m_szSenteName, m_szGoteName );
	csRes += cs;

	if( bMe )
	{
		if( m_nMySide == SENTE )
			cs.LoadString(IDS_SENTE_SYOURI);
		else
			cs.LoadString(IDS_GOTE_SYOURI);
	}
	else
	{
		if( m_nMySide == SENTE )
			cs.LoadString(IDS_GOTE_SYOURI);
		else
			cs.LoadString(IDS_SENTE_SYOURI);
	}
	csRes += cs;
	csRes += _T("\r\n\r\n");

	// 莞
	int Sec = m_nSenteTime%60;
	int Min = m_nSenteTime/60;
	cs.Format(_T("莞\tF%d%02db\r\n"),Min, Sec );
	csRes += cs;

	// 莞
	Sec = m_nGoteTime%60;
	Min = m_nGoteTime/60;
	cs.Format(_T("莞\tF%d%02db\r\n"),Min, Sec );
	csRes += cs;
	
	// v
	Sec = (m_nSenteTime+m_nGoteTime)%60;
	Min = (m_nSenteTime+m_nGoteTime)/60;
	cs.Format(_T("v\tF%d%02db\r\n"),Min, Sec );
	csRes += cs;

	// 萔
	cs.Format(_T("萔\tF%d"), m_pKifu->GetCount()-2);
	csRes += cs;

	CResultDlg dlg;
	dlg.m_eResult = csRes;
	dlg.DoModal();

}

//////////////////////////////////////////////////////////////////////////////
// ЂƂO܂Ŋ߂

BOOL CNSDoc::RollBack(int nCnt)
{
	if((nCnt < 0)|| (nCnt >= m_pKifu->GetCount()) )
		return FALSE;
	for( int ii = 0; ii < nCnt; ii++ )
	{
		if( m_pKifu->IsEmpty() )
			break;
		m_pKifu->RemoveTail();
	}

	// ɍ킹ĔՖʂ쐬
	ReplayKoma(m_pKifu->GetCount());

	
	if(m_pGSrvSocket)
		Send2AllGallary(MSG_GALLARY_KIFUDATA);
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	// TODO:
	if( !m_bOnGame&&!m_bIamGallary )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateFileMruFile1(CCmdUI* pCmdUI) 
{
	if( !m_bOnGame&&!m_bIamGallary )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO:
	if( !m_bOnGame&&!m_bIamGallary )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}


//////////////////////////////////////////////////////////////////////////////
//
void CNSDoc::OnFileCutTail() 
{
	// TODO:
	RollBack(1);
	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return;
	pView->UpdateKifuBar();
}

//////////////////////////////////////////////////////////////////////////////
//

void CNSDoc::OnUpdateFileCutTail(CCmdUI* pCmdUI) 
{
	// TODO:
	if( !m_bOnGame )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
}

void CNSDoc::OnBtlMail() 
{
	// TODO:
	CMailDlg dlg;
	
	m_szMailString = "";
	
	if( dlg.DoModal() == IDOK )
	{
		// [M
		m_szMailString = dlg.m_szMailString;
		SendMsg( MSG_MAIL );
	}

	
}

void CNSDoc::OnUpdateBtlMail(CCmdUI* pCmdUI) 
{
	// TODO:
	if(m_pSocket&&!m_bIamGallary)
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

//////////////////////////////////////////////////////////////////////////////
// ϐ\PbgFANZvg
// ϐT[oBϐ킵Ăl烁bZ[W󂯂
void CNSDoc::GallaryAccept()
{
	CWatchSocket* pWatchSocket = new CWatchSocket(this);

	if (m_pGSrvSocket->Accept(*pWatchSocket))
	{
		pWatchSocket->Init();
		m_connectionList.AddTail(pWatchSocket);
	}
	else
		delete pWatchSocket;
}

//////////////////////////////////////////////////////////////////////////////
// ϐ\PbgFM
// ϐT[oBϐ킵Ăl烁bZ[W󂯂

void CNSDoc::WatchProcessPendingRead(CWatchSocket* pWSocket)
{
	do
	{
		if(!WatchReceiveMsg(pWSocket)||pWSocket==NULL)
			return;
	}
	while (!pWSocket->m_pArchiveIn->IsBufferEmpty());

	if(!m_pApp->m_rgst.m_bWatchAllow)
	{
		SendMsg2Gallary(pWSocket,MSG_DISCONNECT);
		pWSocket->Close();

		// RlNVXg폜
		POSITION pos,temp;
		for(pos = m_connectionList.GetHeadPosition(); pos != NULL;)
		{
			temp = pos;
			CWatchSocket* pSock = (CWatchSocket*)m_connectionList.GetNext(pos);
			if (pSock == pWSocket)
			{
				m_connectionList.RemoveAt(temp);
				break;
			}
		}

		PDELETE( pWSocket );
	}

}

//////////////////////////////////////////////////////////////////////////////
// 炩ُ̈픭ɂFALSEԂ
// ϐҗpT[o\Pbg瑗Ă郁bZ[W

BOOL CNSDoc::WatchReceiveMsg(CWatchSocket* pWSocket)
{
	CNSView* pView = GetSDIView();
	if(pView == NULL)
		return FALSE;

	CMsg msg(this);

	TRY
	{
		pWSocket->ReceiveMsg(&msg);
	}
	CATCH(CFileException, e)
	{
		msg.m_dwCmd = MSG_GALLARY_DISCONNECT;
		pWSocket->Abort();
	}
	END_CATCH

	switch( msg.m_dwCmd )
	{
		case MSG_GALLARY_CONNECT:
		{
			*pWSocket->m_szName = m_szWatcherName;
			SendMsg2Gallary(pWSocket, MSG_GALLARY_KIFUDATA );
			break;
		}
		// ڑIM
		case MSG_DISCONNECT:
		{
			pWSocket->Close();

			// RlNVXg폜
			POSITION pos,temp;
			for(pos = m_connectionList.GetHeadPosition(); pos != NULL;)
			{
				temp = pos;
				CWatchSocket* pSock = (CWatchSocket*)m_connectionList.GetNext(pos);
				if (pSock == pWSocket)
				{
					m_connectionList.RemoveAt(temp);
					break;
				}
			}

			PDELETE( pWSocket );
			return FALSE;
			break;
		}
		default:
			break;
	}
	return TRUE;
}

void CNSDoc::OnConWatch() 
{
	// TODO:
	// TODO:
	CWaitCursor wait;
	
	if( m_pSocket != NULL )
	{
		AfxMessageBox(_T("܂ڑł"),MB_ICONEXCLAMATION );
		return;
	}

	if( m_pSrvSocket != NULL )
	{
		AfxMessageBox(_T("T[oƂđҋ@ł"),MB_ICONEXCLAMATION );
		return;
	}

	// ڑ_CAO
	CClientDLG	dlg;
	
	dlg.m_szHandleName = m_pApp->m_rgst.m_szMyName;
	dlg.m_nPortNo = m_pApp->m_rgst.m_nDefPortNo;
	dlg.m_szServer = m_pApp->m_rgst.m_szDefServerName;
	
	while( TRUE )
	{
		if (IDOK != dlg.DoModal()){
			return;
		}
		
		// ڑ
		if (ConnectSocket(dlg.m_szHandleName, dlg.m_szServer, dlg.m_nPortNo+1))
		{

			m_pApp->m_rgst.m_szMyName = dlg.m_szHandleName;
			m_pApp->m_rgst.m_nDefPortNo = dlg.m_nPortNo;
			m_pApp->m_rgst.m_szDefServerName = dlg.m_szServer;
			m_bIamGallary = TRUE;
			SendMsg( MSG_GALLARY_CONNECT );
			return;
		}

		if( AfxMessageBox(_T("ݒςĂxH"),MB_YESNO|MB_ICONQUESTION) == IDNO )
			return;
	}
	
	
}

void CNSDoc::OnUpdateConWatch(CCmdUI* pCmdUI) 
{
	// TODO:
	if( m_pSocket != NULL || m_pSrvSocket != NULL )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
	
	
}

void CNSDoc::Send2AllGallary(DWORD dwCommand)
{
	for(POSITION pos = m_connectionList.GetHeadPosition(); pos != NULL;)
	{
		CWatchSocket* pWSocket = (CWatchSocket*)m_connectionList.GetNext(pos);
		SendMsg2Gallary(pWSocket, dwCommand);
	}
}

void CNSDoc::SendMsg2Gallary(CWatchSocket* pWSocket, DWORD dwCommand)
{
	if(pWSocket==NULL)
		return;

	if (pWSocket->m_pArchiveOut != NULL)
	{
		// bZ[W̍쐬
		CMsg msg(this);
		msg.m_dwCmd = dwCommand;
		// M
		TRY
		{
			pWSocket->SendMsg(&msg);
		}
		CATCH(CFileException, e)
		{
			pWSocket->m_pArchiveOut->Abort();
			PDELETE(pWSocket->m_pArchiveOut);

			pWSocket->Close();

			// RlNVXg폜
			POSITION pos,temp;
			for(pos = m_connectionList.GetHeadPosition(); pos != NULL;)
			{
				temp = pos;
				CWatchSocket* pSock = (CWatchSocket*)m_connectionList.GetNext(pos);
				if (pSock == pWSocket)
				{
					m_connectionList.RemoveAt(temp);
					break;
				}
			}

			PDELETE( pWSocket );

		}
		END_CATCH
	}
}

// ݒ
void CNSDoc::OnBtlInit() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CUwateDlg	dlg(&m_koma);
	if( IDOK == dlg.DoModal() )
	{
		m_koma.m_nOti = dlg.m_nOption;
		Init();
		UpdateMyView();
	}
}

void CNSDoc::OnUpdateBtlInit(CCmdUI* pCmdUI) 
{
	// TODO:
	if(!m_bOnGame)
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );
	
}

void CNSDoc::OnConProp() 
{
	// TODO:
	CSockStatus	dlg(this);
	dlg.DoModal();
}


BOOL WriteResultStatus( CString name, int nWin, int nLose )
{
	char szWin[255], szLose[255];
	wsprintf( szWin, "%d",nWin );
	wsprintf( szLose, "%d",nLose );

	::WritePrivateProfileString(name, _T("WIN"), szWin, NETSHOGIFILE);
	::WritePrivateProfileString(name, _T("LOSE"), szLose, NETSHOGIFILE);

	return TRUE;
}
BOOL ReadResultStatus( CString name, int* nWin, int* nLose )
{
	*nWin = ::GetPrivateProfileInt(name, _T("WIN"), 0, NETSHOGIFILE);
	*nLose = ::GetPrivateProfileInt(name, _T("LOSE"), 0, NETSHOGIFILE);

	return FALSE;
}


void CNSDoc::OnFileSaveKifStyle() 
{
	CString strFileExtentFilter;
	strFileExtentFilter.LoadString(IDS_FILE_EXTENT_FILTER);

	// Z[ut@C_CAO
	CFileDialog	dlg(
		FALSE,
		_T("kif"), 
		_T(""), 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		strFileExtentFilter,
		AfxGetMainWnd());
	
	int nResponse = dlg.DoModal();
	
	if (nResponse == IDOK)
	{
		CString strF(dlg.GetPathName());

		CStdioFile f;
		if( !f.Open(strF, CFile::modeCreate | CFile::modeWrite | CFile::typeText) )
		{
			AfxMessageBox( IDS_FILEOPENERROR, MB_OK );
			return;
		}

		CString strFormat;	//	ϊpobt@
		CString strXLine;	//	s݃obt@
		
		// -- title
		f.WriteString(_T("# ----  ʐMV2.8 `،`(KIF)Ήt@C  ----\n"));
		f.WriteString(_T("# ----  ܃eXgł̂ŕs΁A  ----\n"));
		f.WriteString(_T("# ----  e-mail:yu-ishi@ya2.so-net.ne.jp ܂ŁB    ----\n"));
		
		// -- file name
		strXLine.Format(_T("# t@CF%s\n"), dlg.GetPathName());
		f.WriteString(strXLine);
		
		// -- start time
		strXLine = m_timStart.Format(_T("JnF%Y/%m/%d %H:%M:%S\n") );
		f.WriteString(strXLine);

		// -- end time
		CTime endt = CTime::GetCurrentTime();
		strXLine = endt.Format( "IF%Y/%m/%d %H:%M:%S\n" );
		f.WriteString(strXLine);

		// -- teai
		CString csTeai;
		m_koma.GetTeaiString(csTeai);
		strXLine.Format(_T("荇F%s\n"),	csTeai );
		f.WriteString(strXLine);
		
		// 1st player
		if( m_szSenteName == _T("") )
			strFormat = _T("^");
		else
			strFormat = m_szSenteName;

		strXLine.Format(_T("F%s\n"),		strFormat );
		f.WriteString(strXLine);


		// 2nd player
		if( m_szGoteName == _T("") )
			strFormat = _T("^");
		else
			strFormat = m_szGoteName;

		strXLine.Format(_T("F%s\n"),		strFormat );
		f.WriteString(strXLine);

		// title
		f.WriteString(_T("\n萔----w-----------\n"));

		CListBox* pLB = ((CMainFrame*)AfxGetMainWnd())->GetKifuBar();

		for( int lbindex = 1; lbindex < pLB->GetCount(); lbindex++ )
		{
			pLB->GetText( lbindex, strFormat );
			if( strFormat == _T("") )
				break;
			strFormat.Replace(_T(""),_T(""));
			strFormat.Replace(_T(""),_T(""));

			// f[^𕪉
			int no = HIWORD(pLB->GetItemData(lbindex));
			// f[^̎
			if( 0 <= no && 39 >= no )
			{
				strXLine.Format( _T("%4d %s\n"),lbindex, strFormat );
			}
			else
			{
				strXLine.Format( _T("%s\n"), strFormat );
			}
			f.WriteString( strXLine );
		}

		//m_pKifu->GetCount()-2

	}
}
