// NSView.cpp : CNSView NX̓̒`s܂B
//

#include "stdafx.h"
#include "nshogi2.h"

#include "NSDoc.h"
#include "NSView.h"
#include "Msg.h"
#include "MainFrm.h"	//ishi

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MM_CANTMOVE		1
#define MM_MYSIDEONLY	2
#define MM_ALLOWALL		3

/////////////////////////////////////////////////////////////////////////////
// CNSView

IMPLEMENT_DYNCREATE(CNSView, CView)

BEGIN_MESSAGE_MAP(CNSView, CView)
	//{{AFX_MSG_MAP(CNSView)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNSView NX̍\z/

CNSView::CNSView()
{
	m_KSize = CSize(0,0);		// ftHg̋̃TCY
	m_pKImg = NULL;				// C[W̕ۊǏꏊ
	m_pXYNoImg = NULL;			// wx\pC[W̕ۊǏꏊ
	m_oldPoint = CPoint(-1,-1);	// ړ̘g`Ɏgp
	m_bDragging = FALSE;		// hbO
	m_nDraggingNo = -1;			// hbŐNo
	m_nMoveMode = MM_ALLOWALL;	// ǂ̋𓮂邩
	m_bFlashFlag=FALSE;			// ̓_

	// Ղ̂wx\pC[WXg
	CBitmap cbm;
	TRY
	{
		cbm.LoadBitmap(IDB_NUMBER);

		PDELETE(m_pXYNoImg)
		m_pXYNoImg = new CImageList();

		m_pXYNoImg->Create(15,15,ILC_COLOR8|ILC_MASK,18,1);
		m_pXYNoImg->Add( &cbm, RGB(0,0,255) );

	}
	CATCH(CMemoryException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	CATCH(CResourceException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	END_CATCH
	cbm.DeleteObject();


}

/////////////////////////////////////////////////////////////////////////////
//
CNSView::~CNSView()
{
	PDELETE(m_pKImg)
	PDELETE(m_pXYNoImg)
}

/////////////////////////////////////////////////////////////////////////////
//
BOOL CNSView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CNSView NX̕`

void CNSView::OnDraw(CDC* pDC)
{
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CKoma* pKoma = &pDoc->m_koma;
	ASSERT(pKoma!=NULL);

	CDC		memDC;
	CBitmap	bmp, *poldbmp;
	RECT	rc;

	// EBhẼTCY擾
	GetClientRect( &rc );

	// cb̍쐬
	memDC.CreateCompatibleDC( pDC );
	bmp.CreateCompatibleBitmap( pDC, rc.right, rc.bottom );
	poldbmp = memDC.SelectObject( &bmp );

	// e`
	DrawBGround(&memDC);
	DrawBan(&memDC);
	DrawKoma(&memDC, pKoma);

	// cbNCAgcbɃRs[
	pDC->StretchBlt( 0, 0, rc.right, rc.bottom, &memDC,
					 0, 0, rc.right, rc.bottom, SRCCOPY );

	memDC.SelectObject( poldbmp );
	bmp.DeleteObject();
}

/////////////////////////////////////////////////////////////////////////////
// CNSView NX̐ff

#ifdef _DEBUG
void CNSView::AssertValid() const
{
	CView::AssertValid();
}

void CNSView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CNSDoc* CNSView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNSDoc)));
	return (CNSDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNSView NX̃bZ[W nh

void CNSView::DrawBGround(CDC * pDC)
{
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	int nViewGray = (int)pApp->m_rgst.m_bViewGray;

	CRect rc;
	GetClientRect(&rc);
	DrawTile(pDC,rc,IDB_TILE+nViewGray);
}

/////////////////////////////////////////////////////////////////////////////
//

void CNSView::DrawBan(CDC* pDC)
{
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	int nViewGray = (int)pApp->m_rgst.m_bViewGray;

	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Ղ̏n߂̈ʒu
	CPoint cp = GetBasePoint();

	// ՃTCY
	CSize ban = CSize(m_KSize.cx * 9,m_KSize.cy * 9);

	// Ղ̃rbg}bv`揈
	//   //
	CRect rc(cp.x-15, cp.y-15, cp.x+ban.cx+15, cp.y+ban.cy+15);

	if(pDC->RectVisible(rc))
	{
		DrawTile(pDC,rc,IDB_BAN + nViewGray);

		// Ր̕`  //
		CPen pen(PS_SOLID,1,RGB(0,0,0)), *pOldpen;
		pOldpen = (CPen*)pDC->SelectObject( &pen );

		for( int ii = 0;ii < 10; ii++ )
		{
			// c
			pDC->MoveTo(cp.x+(ii*m_KSize.cx), cp.y);
			pDC->LineTo(cp.x+(ii*m_KSize.cx), cp.y+ban.cy);
			// 
			pDC->MoveTo(cp.x, cp.y+(ii*m_KSize.cy));
			pDC->LineTo(cp.x+ban.cx, cp.y+(ii*m_KSize.cy));
		}
		pDC->SelectObject( pOldpen );

		// wx̕\
		CNSDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		for( ii = 0; ii < 9; ii++ )
		{
			int no,kanjino;
			if(pDoc->m_nViewSide)
			{
				no = 8-ii;
				kanjino = ii+9;

				// w
				m_pXYNoImg->Draw( pDC, no, 
					CPoint( cp.x+(ii*m_KSize.cx)+  m_KSize.cx/2-7,cp.y-15), ILD_NORMAL );

				// x
				m_pXYNoImg->Draw( pDC, kanjino, 
					CPoint( cp.x+ban.cx,cp.y+(ii*m_KSize.cy)+  m_KSize.cy/2-7), ILD_NORMAL );
			}
			else
			{
				no = ii;
				kanjino = 17-ii;

				// w
				m_pXYNoImg->Draw( pDC, no, 
					CPoint( cp.x+(ii*m_KSize.cx)+  m_KSize.cx/2-7,cp.y+ban.cy), ILD_NORMAL );

				// x
				m_pXYNoImg->Draw( pDC, kanjino, 
					CPoint( cp.x-15,cp.y+(ii*m_KSize.cy)+  m_KSize.cy/2-7), ILD_NORMAL );
			}
		}

	}

	// u  //
	CRect rc2(cp.x+ban.cx+(m_KSize.cx)-5,cp.y+(m_KSize.cy)-5,
		cp.x+ban.cx+(m_KSize.cx*6)+5,cp.y+ban.cy+5);

	if(pDC->RectVisible(rc2))
		DrawTile(pDC,rc2,IDB_BAN + nViewGray);
	
}

/////////////////////////////////////////////////////////////////////////////
//
void CNSView::DrawKoma(CDC* pDC,CKoma* pKoma)
{
	// Ղ̏n߂̈ʒu
	CPoint cp = GetBasePoint();

	// ՃTCY
	CSize ban = CSize(m_KSize.cx * 9,m_KSize.cy * 9);

	// Ղ̃rbg}bv`揈
	//   //
	CRect rc(cp.x-15, cp.y-15, cp.x+ban.cx+15, cp.y+ban.cy+15);

	if(pDC->RectVisible(rc))
	{
		
		CNSDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		int nMySide=0;
		int	nEnSide=0;
		CPoint	tmpPnt;

		for( int no = 0; no < 40; no++ )
		{
			if( !pKoma->IsEnable(no) )
				continue;

			int	ImgNo = IDtoImgNo( pKoma->GetID(no) );
			if( pKoma->GetSide(no) != pDoc->m_nViewSide )
				ImgNo += 14;
			if( pKoma->IsNari(no) )
				ImgNo++;

			// Տɂꍇ
			if( pKoma->IsActive(no) )
			{
				if(pDoc->m_nViewSide == GOTE)
					pKoma->ReversePoint(no);
				
				tmpPnt = pKoma->GetPoint(no);
				Ban2Pnt(&tmpPnt);
				m_pKImg->Draw( pDC, ImgNo, tmpPnt, ILD_NORMAL );

				if(pDoc->m_nViewSide == GOTE)
					pKoma->ReversePoint(no);
			}
			else	//Տɖꍇ
			{
				// ̎
				if( pKoma->GetSide(no) == pDoc->m_nViewSide )
				{
					tmpPnt.x = 10 + (nMySide%5);
					tmpPnt.y = 8  - (nMySide/5);
					nMySide++;
				}
				// G̎
				else
				{
					tmpPnt.x = 10 + (4-nEnSide%5);
					tmpPnt.y =      (nEnSide/5)+1;
					nEnSide++;
				}
				pKoma->SetPoint( no, tmpPnt );
				Ban2Pnt(&tmpPnt);
				m_pKImg->Draw( pDC, ImgNo, tmpPnt, ILD_NORMAL );
			}
		}
	}
	// End of DrawKoma
}

/////////////////////////////////////////////////////////////////////////////
//
BOOL CNSView::DrawBMP(CDC * pDC, CPoint cp, CBitmap* pBM)
{
	// `揈
	CBitmap	*pOldCbm;
	CDC memDC;
	BITMAP	bm;

	// rbg}bv擾
	memDC.CreateCompatibleDC( pDC );
	if( pBM->GetObject( sizeof(BITMAP), &bm ) == 0 )
		return FALSE;
	pOldCbm = memDC.SelectObject( pBM );

	pDC->BitBlt( cp.x, cp.y, bm.bmWidth,bm.bmHeight,&memDC,0,0,SRCCOPY );

	memDC.SelectObject( pOldCbm );
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

// obNOEh̃rbg}bv`
BOOL CNSView::DrawTile(CDC * pDC, CRect rc, int nIndex)
{
	// [W̍쐬
	CRgn rgn;
	rgn.CreateRectRgn( rc.left, rc.top, rc.right, rc.bottom );
	pDC->SelectClipRgn( &rgn );

	// rbg}bṽTCY擾
	BITMAP	bm;
	CBitmap cbm;
	cbm.LoadBitmap( nIndex );
	if( cbm.GetObject( sizeof(BITMAP), &bm ) == 0 )
		return FALSE;

	// Ղ̃rbg}bv̕`
	for( int yy=rc.top; yy<rc.bottom; yy+=(bm.bmHeight) )
		for( int xx=rc.left; xx<rc.right; xx+=(bm.bmWidth) )
			DrawBMP(pDC, CPoint(xx,yy), &cbm);

	cbm.DeleteObject();
	pDC->SelectClipRgn( NULL );
	//
	// ̕`
	CPen pen(PS_SOLID,1,RGB(0,0,0)), *pOldpen;
	pOldpen = (CPen*)pDC->SelectObject( &pen );
	// Og
	pDC->MoveTo(rc.left,rc.top);		// 
	pDC->LineTo(rc.right,rc.top);		// E
	pDC->LineTo(rc.right,rc.bottom);	// E
	pDC->LineTo(rc.left,rc.bottom);		// 
	pDC->LineTo(rc.left,rc.top);		// 
	pDC->SelectObject( pOldpen );

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//  Պ|CgZo
CPoint CNSView::GetBasePoint()
{
	RECT wndRc;
	GetClientRect(&wndRc);
	CPoint cp;
	cp.x = ((wndRc.right-wndRc.left)/2)-((m_KSize.cx/2)*15);
	cp.y = ((wndRc.bottom-wndRc.top)/2)-((m_KSize.cy/2)*9);
	if( cp.x < 0 ) cp.Offset(abs(cp.x),0);
	if( cp.y < 0 ) cp.Offset(0,abs(cp.y));
	return cp;
}

/////////////////////////////////////////////////////////////////////////////
//  Պ|CgNCAg̈Ƀ|CgύX
CPoint CNSView::Ban2Pnt(CPoint * lpPnt)
{
	CPoint cp = GetBasePoint();
	lpPnt->x*=(m_KSize.cx);
	lpPnt->y*=(m_KSize.cy);
	lpPnt->Offset(cp.x,cp.y);
	return *lpPnt;
}

/////////////////////////////////////////////////////////////////////////////
//  NCAg̈悩Պ|CgɃ|CgύX
CPoint CNSView::Pnt2Ban(CPoint * lpPnt)
{
	CPoint cp = GetBasePoint();
	lpPnt->Offset(-cp.x,-cp.y);
	lpPnt->x/=(m_KSize.cx);
	lpPnt->y/=(m_KSize.cy);
	return *lpPnt;
}


/////////////////////////////////////////////////////////////////////////////
// ̔wԍC[Wԍt

int CNSView::IDtoImgNo(int kid)
{
	int	IDtoImgNo[] = { 0, 1, 3, 5, 6, 8, 10, 12, 0 };
	return IDtoImgNo[ kid ];
}


/////////////////////////////////////////////////////////////////////////////
// TCYύX

void CNSView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	ReSizeView(FALSE);
}


/////////////////////////////////////////////////////////////////////////////
// TCYύX[`

void CNSView::ReSizeView(BOOL bPaint)
{
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	int nViewGray = (int)pApp->m_rgst.m_bViewGray;

	CRect rc;
	GetClientRect(&rc);
	int cx = rc.right - rc.left;
	int cy = rc.bottom - rc.top;

	int image, image_r;

	CSize oldSize = m_KSize;
	switch (pApp->m_rgst.m_nViewSize)
	{
		case 1:
		{
			image = IDB_KOMA+nViewGray;
			image_r = IDB_KOMA_R+nViewGray;
			m_KSize = CSize( 32,32 );
			break;
		}
		case 2:
		{
			image = IDB_KOMA40+nViewGray;
			image_r = IDB_KOMA_R40+nViewGray;
			m_KSize = CSize( 40,40 );
			break;
		}
		default:
		{
			if( cx > 600 && cy > 400 )
			{
				image = IDB_KOMA40+nViewGray;
				image_r = IDB_KOMA_R40+nViewGray;
				m_KSize = CSize( 40,40 );
			}
			else
			{
				image = IDB_KOMA+nViewGray;
				image_r = IDB_KOMA_R+nViewGray;
				m_KSize = CSize( 32,32 );
			}
			break;
		}
	}

	//if( m_KSize == oldSize )
	//	return;
	
	// C[W̍č\z
	CWaitCursor waitcur;


	TRY
	{
		CBitmap cbm;
		CBitmap cbm_r;

		cbm.LoadBitmap(image);
		cbm_r.LoadBitmap(image_r);

		if(m_pKImg != NULL)
			PDELETE(m_pKImg);
		
		m_pKImg = new CImageList();

		m_pKImg->Create(m_KSize.cx,m_KSize.cy,ILC_COLOR8|ILC_MASK,15,15);
		m_pKImg->Add( &cbm, RGB(0,0,255) );

		CImageList *pTmpImg = new CImageList;
		pTmpImg->Create(m_KSize.cx,m_KSize.cy,ILC_COLOR8|ILC_MASK,15,15);
		pTmpImg->Add( &cbm_r, RGB(0,0,255) );
		for( int ii = 13; ii >= 0; ii-- )
			m_pKImg->Add( (HICON)pTmpImg->ExtractIcon( ii ) );
		delete pTmpImg;
		cbm.DeleteObject();
		cbm_r.DeleteObject();
	}
	CATCH(CMemoryException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	CATCH(CResourceException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	END_CATCH

	if(bPaint)
		InvalidateRect( NULL, FALSE );
}


/////////////////////////////////////////////////////////////////////////////
//
void CNSView::OnLButtonDown(UINT nFlags, CPoint pntOrg) 
{
	// TODO:
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CKoma* pKoma = &pDoc->m_koma;
	ASSERT(pKoma!=NULL);

	// NbNŋ̓_łI
	m_bFlashFlag = FALSE;

	// XgȂΏI
	CListBox* pList = GetKifuList();
	if( pList == NULL )
		return;
	
	CPoint point = pntOrg;
	m_bDragging = FALSE;
	int kno;

	int tmpMySide = pDoc->m_nMySide;

	// Ղ̉ꂽm肷B
	Pnt2Ban(&point);

	// ̂߂Ɍ݂View̏ꍇƃtO𔽓]B
	if(pDoc->m_nViewSide == GOTE)
	{
		pKoma->ReverseAllFlags();
		tmpMySide = !tmpMySide;
	}

	// ꂽm肷
	kno = pKoma->SerchKomaByPoint( point );
	
	BOOL f__ = TRUE;
	while( f__ )
	{
		f__ = FALSE;		// 񂾂̃[v
		
		// LtO`FbN
		if( !pKoma->IsEnable(kno) )
			break;

		// wԍiǂj`FbN
		if( kno < 0 || kno > 39 )
			break;

		// XgȂ΃Abvf[g
		if(pList->GetCount() < 1)
		{
			UpdateKifuBar();
		}

		// ʐMĂȂAQ[łȂ
		if(  !pDoc->m_bOnGame && pDoc->m_pSocket != NULL  )
			break;
		
		if(  pDoc->m_bOnGame )
		{
			if(  pKoma->GetSide(kno)!=tmpMySide  )
				break;
		}

		// ΋ǒ͎̔ԂłȂƈړs
		if(  (pDoc->m_nViewSide == GOTE)  )
		{
			if(!(
				((pList->GetCount()%2==0) && pKoma->GetSide(kno)==SENTE)||
				((pList->GetCount()%2==1) && pKoma->GetSide(kno)==GOTE)
				))
			break;
		}else{//(pDoc->m_nViewSide == SENTE)
			if(!(
				((pList->GetCount()%2==1) && pKoma->GetSide(kno)==SENTE)||
				((pList->GetCount()%2==0) && pKoma->GetSide(kno)==GOTE)
				))
			break;
		}
		
		///////////////////
		// hbOJn  //
		///////////////////
		m_bDragging = TRUE;
		m_nDraggingNo = kno;
		m_oldPoint = point;
		
		// J[\̃Zbg
		if(pList->GetCount()-1 == pList->GetCurSel() )
			// J[\C[W̍쐬
			ghFingerCur = AfxGetApp()->LoadCursor(IDC_FINGER_CURSOR);
		else
			ghFingerCur = AfxGetApp()->LoadCursor(IDC_FINGER_NORECORD);

		ghOldCur = SetCursor(ghFingerCur);

		// }EXLv`[Jn
		this->SetCapture();

		// hbOC[W̍쐬
		int nDragImgNo = IDtoImgNo(pKoma->GetID(kno));

		if( pKoma->GetSide(kno) == GOTE )
			nDragImgNo += 14;	//]C[W
		
		if( pKoma->IsNari(kno) )
			nDragImgNo++;		// C[W

		// ړ\ȏꏊɔ]\
		CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
		if( pKoma->IsActive(kno)&&(pApp->m_rgst.m_bPrintRoot ))
		{
			CPoint tmpCP;
			CDC* pDC = GetDC();

			for(tmpCP.x = 0; tmpCP.x < 9; tmpCP.x++) {
				for(tmpCP.y = 0; tmpCP.y < 9; tmpCP.y++) {
					if(pKoma->Move(kno,tmpCP,FALSE)==MV_OK) {
						Ban2Pnt(&tmpCP);
						m_pKImg->Draw(pDC,nDragImgNo,tmpCP,ILD_TRANSPARENT|ILD_BLEND25);
						Pnt2Ban(&tmpCP);
					}
				}
			}

			ReleaseDC(pDC);
		}
		
		// ̃hbOJn
		Ban2Pnt(&point);
		CPoint pntSpot = CPoint(pntOrg.x - point.x,pntOrg.y - point.y );
		m_pKImg->BeginDrag(nDragImgNo, pntSpot);
		m_pKImg->DragEnter(this, pntOrg);
	}

	// ̂߂ɔ]ĂՏɖ߂B
	if(pDoc->m_nViewSide == GOTE)
		pKoma->ReverseAllFlags();

	CView::OnLButtonDown(nFlags, pntOrg);
}

/////////////////////////////////////////////////////////////////////////////
//
void CNSView::OnMouseMove(UINT nFlags, CPoint pntOrg) 
{
	// TODO:
	CPoint point = pntOrg;
	if( m_bDragging )
	{
		SetCursor(ghFingerCur);
		// hbO̓C[WXg`悵ړ
		m_pKImg->DragMove( point );
		
		// Ղ̉m肷B
		Pnt2Ban(&point);

		// ՏɂΔ]
		if( CRect( 0, 0, 9, 9 ).PtInRect( point ) && m_oldPoint != point )
		{
			m_pKImg->DragLeave(this);
			WriteRect( m_oldPoint, RGB(0,0,0) );
			WriteRect( point, RGB(255,0,0) );
			m_oldPoint = point;
			m_pKImg->DragEnter( this, pntOrg);
		}
	}

	CView::OnMouseMove(nFlags, pntOrg);
}

/////////////////////////////////////////////////////////////////////////////
// 

void CNSView::OnLButtonUp(UINT nFlags, CPoint pntOrg) 
{
	// TODO:
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CKoma* pKoma = &pDoc->m_koma;
	ASSERT(pKoma!=NULL);

	CPoint point = pntOrg;
	
	// Տ̃|Cg쐬
	Pnt2Ban(&point);

	// hbOȂ΁EEE
	if(m_bDragging)
	{
		BOOL bRollBack = FALSE;
		
		// hbǑn
		m_bDragging = FALSE;
		m_pKImg->EndDrag();
		ReleaseCapture();

		// J[\ɖ߂
		SetCursor(ghOldCur);

		// ̂߂Ɍ݂View̏ꍇƃtO𔽓]B
		if(pDoc->m_nViewSide == GOTE)
		{
			pKoma->ReverseAllFlags();
		}

		// ɂȂ邩ǂ
		int bNariFlag=pKoma->CheckNariFlag(m_nDraggingNo,point);

		// ړ
		if(pKoma->Move(m_nDraggingNo,point,TRUE)==MV_OK)
		{
					
			// Ȃ炴𓾂Ȃ͋Ős
			if(bNariFlag == NR_MUST)
				pKoma->SetNari(m_nDraggingNo, TRUE);
			// Iꍇ͑I
			else if (bNariFlag == NR_ABLE )
			{
				if(IDYES==AfxMessageBox( _T("܂H"), MB_YESNO|MB_ICONQUESTION ))
					pKoma->SetNari(m_nDraggingNo, TRUE);
			}
			
			// ȂxoB
			CListBox* pList = GetKifuList();
			if((pKoma->IsBeDead(pKoma->GetGyokuNo(pKoma->GetSide(m_nDraggingNo))) )&&
				(pDoc->m_bOnGame)&&
				(pList->GetCurSel()==(pList->GetCount()-1)))
			{
				if(IDNO==AfxMessageBox( "ʂ܂B\n낵łH",
								MB_YESNO|MB_ICONQUESTION ))
				{
					bRollBack=TRUE;
				}
			}


			if( bRollBack == FALSE )
			{
				// R[hƂ͋f[^ɖ߂
				if(pDoc->m_nViewSide == GOTE)
				{
					pKoma->ReverseAllFlags();
					WriteRecord(pKoma,m_nDraggingNo);
					pKoma->ReverseAllFlags();
				}
				else
					WriteRecord(pKoma,m_nDraggingNo);
			}
		}

		if(pDoc->m_nViewSide == GOTE)
			pKoma->ReverseAllFlags();

		// ̂ő҂ꍇ̏
		if(bRollBack)
			pDoc->ReplayKoma(pDoc->m_pKifu->GetCount());
		
		// ĕ`
		InvalidateRect( NULL, FALSE );
		
	}
	CView::OnLButtonUp(nFlags, pntOrg);
}

/////////////////////////////////////////////////////////////////////////////
// Պ̃|CgŔՏɐF

void CNSView::WriteRect( CPoint cp, COLORREF rgb )
{
	if( CRect( 0, 0, 9, 9 ).PtInRect(cp) == FALSE )
		return;

	Ban2Pnt(&cp);
	CDC* pDC = GetDC();

	pDC->FrameRect(&CRect(cp.x,cp.y,cp.x+m_KSize.cx+1,cp.y+m_KSize.cy+1),&CBrush(rgb));
	
	ReleaseDC(pDC);
}


/////////////////////////////////////////////////////////////////////////////
// ɏ

void CNSView::WriteRecord(CKoma* pKoma,int no)
{
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// o[ŐṼf[^Ăꍇɂ
	// ɋL^c
	CListBox* pList = GetKifuList();
	if(pList->GetCurSel()==(pList->GetCount()-1))
	{
		pDoc->WriteRecord( no );

		// ̋ʂꂽ`FbN
		if(!pKoma->IsActive(pKoma->GetGyokuNo( !(pKoma->GetSide(no)) )))
		{
			// ΋ǏIs
			pDoc->SendMsg(MSG_GAME_END);

			if(pDoc->m_nMySide==SENTE)
				pDoc->WriteRecord( KOMA_SENTE_SYORI );
			else
				pDoc->WriteRecord( KOMA_GOTE_SYORI );
			
			// ΋ǏI
			pDoc->m_bOnGame = FALSE;
			AfxMessageBox(_T("Ȃ̏łB"),MB_ICONINFORMATION);
			
			// ʕ\
			pDoc->Result(TRUE);
		}
		else
		{
			pDoc->SendMsg(MSG_NOTICE);	// [M̔Ԃł]
			pDoc->SendMsg(MSG_DATA);	// f[^M
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// _̕ύX

void CNSView::OnViewSideChange() 
{
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->m_nViewSide=!pDoc->m_nViewSide;
	InvalidateRect(NULL,FALSE);

	((CMainFrame*)GetParentFrame())->PrintBtlName();
}

//

void CNSView::OnUpdateViewSideChange(CCmdUI* pCmdUI) 
{
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if( pDoc->m_nViewSide == SENTE )
		pCmdUI->SetText(_T("葤ŕ\"));
	else
		pCmdUI->SetText(_T("葤ŕ\"));
}


/////////////////////////////////////////////////////////////////////////////
// Xgւ̃|C^擾

inline CListBox* CNSView::GetKifuList()
{
	CMainFrame* pMf = (CMainFrame*)GetParentFrame();
	if(pMf == NULL)
		return NULL;
	return pMf->GetKifuBar();
}


/////////////////////////////////////////////////////////////////////////////
// o[XV

BOOL CNSView::UpdateKifuBar()
{
	CMainFrame* pMf = (CMainFrame*)GetParentFrame();
	if(pMf == NULL)
		return NULL;
	pMf->UpdateKifuBar();
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// ̓_ŏi^C}[Cxgj

void CNSView::MyTimer(UINT nIDEvent)
{
	static flag = 0;
	CNSDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CKoma* pKoma = &pDoc->m_koma;
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();

	if(  ((!m_bFlashFlag)*flag) || /*(!pDoc->m_bOnGame )||*/( !pApp->m_rgst.m_nFlashOn )  )
		return;

	CListBox* pList = GetKifuList();
	
	if( pList == NULL )
		return;
	
	if(pList->GetCurSel()!=(pList->GetCount()-1)	// XgŌȊO͓_łȂB
		|| ( pList->GetCount() <= 1 ) )				// Xg̎n߂͓_łȂB
		return;

	flag = !flag;
	int no = HIWORD(pDoc->m_pKifu->GetTail());
	int kid = pDoc->m_koma.GetID( no );

	if(( no < 0 || no > 39 ) || (kid < GYOKU || kid > FU ))
		return;

	int	ImgNo = IDtoImgNo( pKoma->GetID(no) );
	
	if( pKoma->GetSide(no) != pDoc->m_nViewSide )
		ImgNo += 14;
	
	if( pKoma->IsNari(no) )
		ImgNo++;

	if(pDoc->m_nViewSide == GOTE)
		pKoma->ReversePoint(no);
	
	CPoint tmpPnt = pKoma->GetPoint(no);
	Ban2Pnt(&tmpPnt);
	
	// ]Ƃ25%uhł

	CDC* pDC = GetDC();
	if( flag )
		m_pKImg->Draw(pDC, ImgNo, tmpPnt, 
					ILD_NORMAL);
	else
		m_pKImg->Draw(pDC, ImgNo, tmpPnt,
					ILD_TRANSPARENT|ILD_BLEND25);
	ReleaseDC(pDC);

	if(pDoc->m_nViewSide == GOTE)
		pKoma->ReversePoint(no);
}
