#include "stdafx.h"
#include "nshogi2.h"
#include "regist.h"
#include "koma.h"

#define REGISTSETTING	_T("Settings")

/////////////////////////////////////////////////////////////////////////////
// CRegist

IMPLEMENT_SERIAL( CRegist, CObject, 1 )

/////////////////////////////////////////////////////////////////////////////
// CRegist construction/destruction

CRegist::CRegist()
{
}

CRegist::~CRegist()
{
}

/////////////////////////////////////////////////////////////////////////////
// serialization

void CRegist::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// diagnostics

#ifdef _DEBUG
void CRegist::AssertValid() const
{
	CObject::AssertValid();
}

void CRegist::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG

void CRegist::Init()
{
}

void CRegist::Load()
{
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	//-- VFAEFAo^ --
	m_szRegisted =	pApp->GetProfileString( REGISTSETTING, _T("m_szRegisted"), 0 );
	//-- \nݒ --
	m_bToolBar =	pApp->GetProfileInt( REGISTSETTING, _T("m_bToolBar"), 1 );
	m_bKifuBar =	pApp->GetProfileInt( REGISTSETTING, _T("m_bKifuBar"), 1 );
	m_bStatusBar =	pApp->GetProfileInt( REGISTSETTING, _T("m_bStatusBar"), 1 );
	m_bWatchAllow =	pApp->GetProfileInt( REGISTSETTING, _T("m_bWatchAllow"), 1 );
	m_nFlashOn =	pApp->GetProfileInt( REGISTSETTING, _T("m_nFlashOn"), 0 );
	m_nViewSize =	pApp->GetProfileInt( REGISTSETTING, _T("m_nViewSize"), 0 );
	m_bPrintRoot =	pApp->GetProfileInt( REGISTSETTING, _T("bPrintRoot"), 1 );
	m_bOuteNotice =	pApp->GetProfileInt( REGISTSETTING, _T("OuteNotice"), 1 );
	m_nSoundOn =	pApp->GetProfileInt( REGISTSETTING, _T("SoundOn"), 1 );
	m_nMessageOn =	pApp->GetProfileInt( REGISTSETTING, _T("MessageOn"), 1 );
	//-- Ԑݒ --
	m_nTime =		pApp->GetProfileInt( REGISTSETTING, _T("m_nTimer"), 7200 );
	m_nDefaultCounter =	pApp->GetProfileInt( REGISTSETTING, _T("m_nDefaultCounter"), 30 );
	m_bCountUp =	pApp->GetProfileInt( REGISTSETTING, _T("m_bCountUp"), 0 );
	//-- TCPIPݒ
	m_szDefServerName = pApp->GetProfileString( REGISTSETTING, _T("DefServer"), "localhost" );
	m_nDefPortNo =	pApp->GetProfileInt( REGISTSETTING, _T("DefPort"), 80 );
	m_szMyName =	pApp->GetProfileString( REGISTSETTING, _T("DefName"), "Name" );

	m_bViewGray =	pApp->GetProfileInt( REGISTSETTING, _T("m_bViewGray"), 0 );

}

void CRegist::Save()
{
	CNShogiApp* pApp = (CNShogiApp*)AfxGetApp();
	//-- VFAEFAo^ --
	pApp->WriteProfileString( REGISTSETTING,	_T("m_szRegisted"),m_szRegisted );
	//-- \nݒ --
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bToolBar"),m_bToolBar );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bKifuBar"),m_bKifuBar );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bStatusBar"),m_bStatusBar );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bWatchAllow"),m_bWatchAllow );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_nFlashOn"),m_nFlashOn );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_nViewSize"),m_nViewSize );
	pApp->WriteProfileInt( REGISTSETTING,		_T("bPrintRoot"),m_bPrintRoot );
	pApp->WriteProfileInt( REGISTSETTING,		_T("OuteNotice"),m_bOuteNotice );
	pApp->WriteProfileInt( REGISTSETTING,		_T("SoundOn"),	m_nSoundOn );
	pApp->WriteProfileInt( REGISTSETTING,		_T("MessageOn"),m_nMessageOn );
	//-- Ԑݒ --
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_nTimer"),m_nTime );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_nDefaultCounter"),m_nDefaultCounter );
	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bCountUp"),m_bCountUp );
	//-- TCPIPݒ
	pApp->WriteProfileString( REGISTSETTING,	_T("DefServer"),m_szDefServerName );
	pApp->WriteProfileString( REGISTSETTING,	_T("DefName"),	m_szMyName );
	pApp->WriteProfileInt( REGISTSETTING,		_T("DefPort"),	m_nDefPortNo );

	pApp->WriteProfileInt( REGISTSETTING,		_T("m_bViewGray"),m_bViewGray );

}
